<?php

class ElementPositionMapper
{
    /**
     * ElementPositionMapper constructor
     *
     * This class cannot be instantiated
     */
    private function __construct()
    {
    }
    
    
    /**
     * The position inside the json file differs from the actually needed one
     * in the Database. This method translates the position
     *
     * @param \StringType $position
     *
     * @return string
     * @throws \Exception
     */
    public static function getElementPositionForDatabase(StringType $position)
    {
        switch ($position->asString()) {
            case 'start' :
            case 'header' :
            case 'boxes' :
            case 'footer' :
            case 'withdrawal' :
                
                return 'elements_' . $position->asString();
            
            case 'other' :
                
                return 'elements_others';
            
            default :
                
                throw new Exception('Unknown ElementPosition(' . $position->asString() . ')');
        }
    }
}